
/*
** (c) 2003 Herbert Poetzl
**
** V0.01	test for syscall
**
*/

#define VERSION "V0.01"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <syscall.h>
#include <asm/unistd.h>
#include <unistd.h>
#include <sched.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/mount.h>

 
#include "vswitch.h"
#undef	ENOTSUP
#include <linux/vserver/switch.h>
#include <linux/vserver/context.h>
#include <linux/vserver/signal.h>


static	char	err_flag = 0;

static	char	opt_vers = 0;

static	char *	cmd_name = NULL;

static	int 	num_ctx = 0;
static	int	num_flag = 0;

static	uint64_t	flags = 0, mask = 0;

#define OPTIONS "+hS:C:x:V"

int	main(int argc, char *argv[])
{
        extern int optind;
        extern char *optarg;
        char c, errflg = 0;
	int r;


        cmd_name = argv[0];
        while ((c = getopt(argc, argv, OPTIONS)) != EOF) {
            switch (c) {
            case 'h':
                fprintf(stderr,
                    "This is %s " VERSION "\n"
                    "options are:\n"
                    "-h        print this help message\n"
                    "-x <num>  context id\n"
                    "-S <num>  set flag number <num>\n"
                    "-C <num>  clear flag number <num>\n"
                    "-V        verify interface version\n"
                    "--        end of options\n"
                    ,cmd_name);
                exit(0);
                break;
            case 'x':
                num_ctx = atol(optarg);
                break;
            case 'S':
                num_flag = atol(optarg);
		flags |= (1 << num_flag);
		mask |= (1 << num_flag);
                break;
            case 'C':
                num_flag = atol(optarg);
		flags &= ~(1 << num_flag);
		mask |= (1 << num_flag);
                break;
            case 'V':
                opt_vers = 1;
                break;
            case '?':
            default:
                errflg++;
                break;
            }
        }
        if (errflg) {
            fprintf(stderr, 
                "Usage: %s -[" OPTIONS "]\n"
                "%s -h for help.\n",
                cmd_name, cmd_name);
            exit(2);
        }

	if (opt_vers) {
	    r = vserver(VCMD_get_version, 0, NULL);
	    if (r<0)
	    	perror("vc_get_version");
    	    else 
	    	printf("version: %04x:%04x\n", 
		    (r>>16)&0xFFFF, r&0xFFFF);
	}

	{
	    struct vcmd_ctx_flags_v0 data = { flags, mask };

	    r = vserver(VCMD_set_flags, num_ctx, &data);
	    if (r)
	    	perror("vc_set_flags");
	}
	
	exit((err_flag)?1:0);
}

